Логотип сайта поддержки пользователей САПРО сайте поддержки пользователей САПР Translate to:

Размещение текста со значением площади возле выбранной полилинии

Назад к списку функций
;;; AreaText.LSP ver 3.0
;;; Запуск: наберите в командной строке AT
;;; Выберите полилинию и место, где вы собираетесь разместить текст
;;; Пример результата: 2888.89 SQ. FT.
;;; Так как оно имеет тип FIELD, то обновляется на основе FIELDEVAL
;;; или параметров, находящихся в диалоговом окне OPTIONS

;;; Для определения высоты текста используйте команду TEXTSIZE

(defun Get-ObjectIDx64 (obj / util)
  (setq util (vla-get-Utility (vla-get-activedocument (vlax-get-acad-object))))
  (if (= (type obj) 'ENAME)(setq obj (vlax-ename->vla-object obj)))
  (if (= (type obj) 'VLA-OBJECT)
    (if (> (vl-string-search "x64" (getvar "platform")) 0)
      (vlax-invoke-method util "GetObjectIdString" obj :vlax-False)
      (rtos (vla-get-objectid obj) 2 0)
    )
  )
)

(defun c:AT (/ entObject entObjectID InsertionPoint ad)
  (vl-load-com)
  (setq entObject (vlax-ename->vla-object(car (entsel)))
        entObjectID (Get-ObjectIDx64 entObject)
        InsertionPoint (vlax-3D-Point (getpoint "Select point: "))
        ad (vla-get-ActiveDocument (vlax-get-acad-object))
  )
  (vla-addMText (if (= 1 (vla-get-activespace ad))
    (vla-get-modelspace ad)
    (if (= (vla-get-mspace ad) :vlax-true)
      (vla-get-modelspace ad)
      (vla-get-paperspace ad)
    )
  )
  InsertionPoint 0.0 (strcat
  "%<\\AcObjProp Object(%<\\_ObjId "
  entObjectID
  ">%).Area \\f \"%pr2%lu2%ct4%qf1 SQ. FT.\">%"
  ))
)



Copyright © Сайт поддержки пользователей САПР by Victor Tkachenko